commit 9f2201bf48e828a7072616fff9dbd64367dcea30
Author: Marek Polacek <polacek@redhat.com>
Date:   Mon Jan 24 22:24:47 2022

    c++: ICE with noexcept and canonical types [PR101715]
    
    This is a "canonical types differ for identical types" ICE, which started
    with r11-4682.  It's a bit tricky to explain.  Consider:
    
      template <typename T> struct S {
        S<T> bar() noexcept(T::value);  // #1
        S<T> foo() noexcept(T::value);  // #2
      };
    
      template <typename T> S<T> S<T>::foo() noexcept(T::value) {}  // #3
    
    We ICE because #3 and #2 have the same type, but their canonical types
    differ: TYPE_CANONICAL (#3) == #2 but TYPE_CANONICAL (#2) == #1.
    
    The member functions #1 and #2 have the same type.  However, since their
    noexcept-specifier is deferred, when parsing them, we create a variant for
    both of them, because DEFERRED_PARSE cannot be compared.  In other words,
    build_cp_fntype_variant's
    
      tree v = TYPE_MAIN_VARIANT (type);
      for (; v; v = TYPE_NEXT_VARIANT (v))
        if (cp_check_qualified_type (v, type, type_quals, rqual, raises, late))
          return v;
    
    will *not* find an existing variant when creating a method_type for #2, so we
    have to create a new one.
    
    But then we perform delayed parsing and call fixup_deferred_exception_variants
    for #1 and #2.  f_d_e_v will replace TYPE_RAISES_EXCEPTIONS with the newly
    parsed noexcept-specifier.  It also sets TYPE_CANONICAL (#2) to #1.  Both
    noexcepts turned out to be the same, so now we have two equivalent variants in
    the list!  I.e.,
    
    +-----------------+      +-----------------+      +-----------------+
    |      main       |      |      #2         |      |      #1         |
    | S S::<T379>(S*) |----->| S S::<T37c>(S*) |----->| S S::<T37a>(S*) |----->NULL
    |    -            |      |  noex(T::value) |      |  noex(T::value) |
    +-----------------+      +-----------------+      +-----------------+
    
    Then we get to #3.  As for #1 and #2, grokdeclarator calls build_memfn_type,
    which ends up calling build_cp_fntype_variant, which will use the loop
    above to look for an existing variant.  The first one that matches
    cp_check_qualified_type will be used, so we use #2 rather than #1, and the
    TYPE_CANONICAL mismatch follows.  Hopefully that makes sense.
    
    As for the fix, I didn't think I could rewrite the method_type #2 with #1
    because the type may have escaped via decltype.  So my approach is to
    elide #2 from the list, so when looking for a matching variant, we always
    find #1 (#2 remains live though, which admittedly sounds sort of dodgy).
    
            PR c++/101715
    
    gcc/cp/ChangeLog:
    
            * tree.c (fixup_deferred_exception_variants): Remove duplicate
            variants after parsing the exception specifications.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/cpp0x/noexcept72.C: New test.
            * g++.dg/cpp0x/noexcept73.C: New test.
    
    (cherry picked from commit 3abcbf243239f9576a60f4ce7f8ee4b3fa14784b)

diff --git a/gcc/cp/tree.c b/gcc/cp/tree.c
index 306f61f719e..36ade65c446 100644
--- a/gcc/cp/tree.c
+++ b/gcc/cp/tree.c
@@ -2768,8 +2768,9 @@ fixup_deferred_exception_variants (tree type, tree raises)
 
   /* Though sucky, this walk will process the canonical variants
      first.  */
+  tree prev = NULL_TREE;
   for (tree variant = TYPE_MAIN_VARIANT (type);
-       variant; variant = TYPE_NEXT_VARIANT (variant))
+       variant; prev = variant, variant = TYPE_NEXT_VARIANT (variant))
     if (TYPE_RAISES_EXCEPTIONS (variant) == original)
       {
 	gcc_checking_assert (variant != TYPE_MAIN_VARIANT (type));
@@ -2779,18 +2780,27 @@ fixup_deferred_exception_variants (tree type, tree raises)
 	    cp_cv_quals var_quals = TYPE_QUALS (variant);
 	    cp_ref_qualifier rqual = type_memfn_rqual (variant);
 
+	    /* If VARIANT would become a dup (cp_check_qualified_type-wise)
+	       of an existing variant in the variant list of TYPE after its
+	       exception specification has been parsed, elide it.  Otherwise,
+	       build_cp_fntype_variant could use it, leading to "canonical
+	       types differ for identical types."  */
 	    tree v = TYPE_MAIN_VARIANT (type);
 	    for (; v; v = TYPE_NEXT_VARIANT (v))
-	      if (TYPE_CANONICAL (v) == v
-		  && cp_check_qualified_type (v, variant, var_quals,
-					      rqual, cr, false))
-		break;
+	      if (cp_check_qualified_type (v, variant, var_quals,
+					   rqual, cr, false))
+		{
+		  /* The main variant will not match V, so PREV will never
+		     be null.  */
+		  TYPE_NEXT_VARIANT (prev) = TYPE_NEXT_VARIANT (variant);
+		  break;
+		}
 	    TYPE_RAISES_EXCEPTIONS (variant) = raises;
 
 	    if (!v)
 	      v = build_cp_fntype_variant (TYPE_CANONICAL (variant),
 					   rqual, cr, false);
-	    TYPE_CANONICAL (variant) = v;
+	    TYPE_CANONICAL (variant) = TYPE_CANONICAL (v);
 	  }
 	else
 	  TYPE_RAISES_EXCEPTIONS (variant) = raises;
diff --git a/gcc/testsuite/g++.dg/cpp0x/noexcept72.C b/gcc/testsuite/g++.dg/cpp0x/noexcept72.C
new file mode 100644
index 00000000000..f1455b3b46b
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp0x/noexcept72.C
@@ -0,0 +1,21 @@
+// PR c++/101715
+// { dg-do compile { target c++11 } }
+
+template <typename T> struct S {
+  S<T> bar() noexcept(T::value);  // #1
+  S<T> foo() noexcept(T::value);  // #2
+};
+
+template <typename T> S<T> S<T>::foo() noexcept(T::value) {}  // #3
+
+template <typename T> struct S2 {
+  S2<T> bar1() noexcept(T::value);
+  S2<T> bar2() noexcept(T::value);
+  S2<T> bar3() noexcept(T::value);
+  S2<T> bar4() noexcept(T::value);
+  S2<T> bar5() noexcept(T::value);
+  S2<T> baz() noexcept(T::value2);
+  S2<T> foo() noexcept(T::value);
+};
+
+template <typename T> S2<T> S2<T>::foo() noexcept(T::value) {}
diff --git a/gcc/testsuite/g++.dg/cpp0x/noexcept73.C b/gcc/testsuite/g++.dg/cpp0x/noexcept73.C
new file mode 100644
index 00000000000..24524f3592a
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp0x/noexcept73.C
@@ -0,0 +1,13 @@
+// PR c++/101715
+// { dg-do compile { target c++11 } }
+
+template <typename T> struct S { };
+
+template<typename T>
+struct A
+{
+    A& foo(A&&) noexcept((S<T>::value));
+    A& assign(A&&) noexcept((S<T>::value));
+};
+template<typename T>
+A<T>& A<T>::foo(A&&) noexcept((S<T>::value)) {}

